# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

#########################

# change 'tests => 1' to 'tests => last_test_to_print';

BEGIN{
    eval "require Storable";
    if ($@) {
	print "1..0 # Skipped: Storable not installed\n";
	exit;
    }
    Storable->import(qw/freeze thaw/);
}

use Test::More tests => 6;
use base 'Class::SingletonMethod::Hash';

my $count = 23;
sub new { bless { id => $count++ }, shift }

my $a = main::->new;
my $b = main::->new;

isa_ok($a, 'Class::SingletonMethod::Hash');
$a->singleton_method(id => sub { $_[0]->{id} });

no warnings 'once'; # for $Storable::Vars
local($Storable::Deparse) = 1;
local($Storable::Eval)    = 1;
my $sa = freeze($a);
my $ta = thaw($sa);

#use Data::Dumper;
#local($Data::Dumper::Deparse) = 1;
#print Dumper $ta;

$ta->isa_ok("main");

ok($ta->can("id"), "a has the new method");
ok(!$b->can("id"), "b does not");
is($ta->id, 23, "It does what I expect it to");

$ta->singleton_method(id => sub { Test::More::ok(1,"Redefining the method works") }); 

$ta->id;
